Doomsday Engine - Feature #1301

Redesigned DED Reader
2003-10-05 10:15 - skyjake

Status: Progressed Start date: 2003-10-05
Priority: High % Done: 80%
Assignee: skyjake

Category: Redesign

Target version: Modding

Description

The DED reader needs to be rewritten.

It will be possible to have more advanced scripting
features, such as:

e constants
e expressions
¢ conditional sections

See proposal

Related issues:

Related to Feature #1608: Integrate Doomsday Script Progressed 2013-10-22
Related to Feature #1244: Scripting in model definitions (e.g., dependent on ... Closed 2003-07-20
Related to Feature #1264: Conditional decorations New 2003-08-12
Related to Feature #1378: DED ver 6 syntax for XG Definitions Rejected 2005-04-10
Related to Bug #346: Overriding Map Info in addons (level par time; jdep) Closed 2006-08-28
History

#1 - 2004-02-18 13:37 - tolwyn
Logged In: YES
user_id=616016

And how about that Ded Manager? That needs to be updated
too!

#2 - 2007-05-17 20:35 - skyjake
Logged In: YES
user_id=717323

I don't intend to update the DED Manager any more. Editing DEDs in a
text editor is much more straightforward and flexible.

#3 - 2009-10-04 21:21 - danij

Logged In: YES
user_id=849456
Originator: NO

| think we've gotten to the end of the road with the current DED reader implementation. Certainly, trying to allow for runtime-specified token structures
(i.e. for game-extendable definitions) would be very tricky to achieve within the current code. We should be thinking about a replacement with run-time
scripting in mind.

Ideas:

Perhaps implement a more robust interface for managing the engine-internal databases and move the actual task of parsing into a dedreader plugin?

#4 - 2013-10-17 12:54 - skyjake
- Tags set to Scripting, Definitions
- Description updated

- Assignee set to skyjake
- % Done changed from 0 to 20

#5 - 2013-10-18 08:44 - skyjake

- Status changed from New to In Progress

#6 - 2013-10-21 08:43 - skyjake
- Priority changed from Normal to High

#7 - 2015-11-10 11:21 - skyjake
- Category set to Redesign
- % Done changed from 20 to 40

Increasing progress because Scriptedinfo now exists and is being used for the GL2 models, and some DED information is already being kept in
Record objects. Two things are needed:

e All DED information should be stored in Record's.
e The DED parser should be relegated to legacy importer status for reading DEDv1 files into the runtime data structures.

The definitions in the (upcoming) game plugins packages should be converted to Scriptedinfo syntax.

#8 - 2016-07-06 00:00 - skyjake
- % Done changed from 40 to 60

#9 - 2016-07-22 09:12 - skyjake

- Status changed from In Progress to Progressed

#10 - 2019-11-29 16:27 - skyjake
- % Done changed from 60 to 80

The DED parser is pretty much in maintenance mode already, and definitions are accessible internally via Defs.

#11 - 2019-11-29 16:27 - skyjake

- Target version set to Modding
